<?php
/*
Plugin Name: Category Icons Widget
Description: Use this widget to display category icons in a sidebar.
Author: Brahim Machkouri
Plugin URI: http://wordpress.org/extend/plugins/category-icons/
Author URi: http://categoryicons.wordpress.com
Version: 2.0.1
*/

function bm_caticons_widget_description( $string) {
	if (strcmp("Use this widget to display category icons in a sidebar.", trim($string)) == 0) 
		$string = __("Use this widget to display category icons in a sidebar.",'category_icons');
	return $string;
}
add_filter('pre_kses','bm_caticons_widget_description' );

function widget_caticons_init() {
	if ( !function_exists('register_sidebar_widget') || !function_exists('put_cat_icons') ) 		return;
	load_plugin_textdomain('category_icons','wp-content/plugins/category-icons/languages/');
	$description = __( 'Easily assign icons to your categories','category_icons' );
	// Register widget for use
	$widget_ops = array('classname' => 'widget_caticons', 'description' => $description );
	$name = __('Category Icons','category_icons');
	//$id = sanitize_title($name);
	$id = sanitize_title('Category Icons');
	wp_register_sidebar_widget($id, $name, 'widget_caticons',$widget_ops);
	// Register settings for use 400x220 pixel form
	register_widget_control($id, 'widget_caticons_control','',220);//, 400 , 220); 
	$current = get_option('active_plugins');
}

// Settings form
function widget_caticons_control() {
	// Get options
	$options = get_option('widget_caticons');
	// options exist? if not set defaults
	if ( !is_array($options) )
		//$options = array('title'=>__('Categories'), 'exclude'=>'');
		$options = array('title'=>'', 'exclude'=>'');
	
	 // form posted?
	if ( $_POST['caticons-submit'] ) {
		// Remember to sanitize and format use input appropriately.
		$options['title'] = strip_tags(stripslashes($_POST['caticons-title']));
		$options['exclude'] = strip_tags(stripslashes($_POST['caticons-exclude']));
		$options['count'] = isset($_POST['caticons-count']);
		$options['hierarchical'] = isset($_POST['caticons-hierarchical']);
		$options['putcaticons_parameters'] = strip_tags(stripslashes($_POST['caticons-putcationsargs']));
		update_option('widget_caticons', $options);
	}
	// Get options for form fields to show
	$title =  htmlspecialchars($options['title'], ENT_QUOTES);
	$exclude = htmlspecialchars($options['exclude'], ENT_QUOTES);
	$putcaticons_parameters = htmlspecialchars($options['putcaticons_parameters'], ENT_QUOTES);
	$count =  $options['count'] ? ' checked="checked"' : '';
	$hierarchical = $options['hierarchical'] ? ' checked="checked"' : '';
	// The form fields 
	?>
<p>
	<label for="caticons-title">
		<?php _e('Title:'); // _e('Title'); ?>
        <input class="widefat" id="caticons-title" name="caticons-title" type="text" value="<?php echo $title; ?>" />
	</label>
</p>
<p>
	<label for="caticons-count">
        <input type="checkbox" class="checkbox" id="caticons-count" name="caticons-count"<?php echo $count; ?> />
        <?php _e( 'Show post counts'); ?>
	</label><br />
	<label for="caticons-hierarchical">
        <input type="checkbox" class="checkbox" id="caticons-hierarchical" name="caticons-hierarchical"<?php echo $hierarchical; ?> />
        <?php _e( 'Show hierarchy' ); ?>
	</label></p>
<p>
	<label for="caticons-putcationsargs">
        <?php _e('put_cat_icons() parameters:','category_icons'); ?><br />
        <input class="widefat" id="caticons-putcationsargs" name="caticons-putcationsargs" type="text" value="<?php echo $putcaticons_parameters; ?>" />
	</label>
</p>
<p>
	<label for="caticons-exclude">
    	<?php _e('Exclude:'); ?>
    	<input class="widefat" id="caticons-exclude" name="caticons-exclude" type="text" value="<?php echo $exclude; ?>" /><br/>
        <small><?php _e('Category IDs, separated by commas.','category_icons'); ?></small>
</label></p>
	<input type="hidden" id="caticons-submit" name="caticons-submit" value="1" />
<?php
}

function widget_caticons($args, $number = 1) {
	extract($args);
	$options = get_option('widget_caticons');
	$c = $options['count'] ? '1' : '0';
	$h = $options['hierarchical'] ? '1' : '0';
	$exclude = $options['exclude'];
	if (empty($exclude)) $exclude = '0';
	$title = empty($options['title']) ? __('Categories') : $options['title'];
	echo $before_widget . $before_title . $title . $after_title;
	$cat_args = "orderby=name&show_count={$c}&hierarchical={$h}&exclude={$exclude}";
	$putcaticons_parameters = $options['putcaticons_parameters'];
?>
		<ul>
		<?php
			if (!empty($putcaticons_parameters)) 
				put_cat_icons(wp_list_categories($cat_args . '&echo=0&title_li='), $putcaticons_parameters); 
			else
				put_cat_icons(wp_list_categories($cat_args . '&echo=0&title_li=')); 
		?>
		</ul>
<?php
	echo $after_widget;
}

// Run code and init
add_action('widgets_init', 'widget_caticons_init');
?>